package com.bull.cimero.pluginEditor.editors.model.BCModel;

import com.bull.cimero.pluginEditor.utils.log.CimeroLog;

/**
 * The screen output cimero model.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class ScreenOutput extends BindingComponentModel {

	/** serial UID. */
	private static final long serialVersionUID = 7139461724713019481L;
	/** default name. */
	private static final String DEFAULTNAME = "myScreenOutput";
	/**The id of this element.*/
	private static final String ID = "Screen";

	/**
	 * default constructor.
	 */
	public ScreenOutput() {
		super(DEFAULTNAME);
		if (setInput(true)) {
			setOutput(false);
		}
		//set property
		setProperty(NAME, DEFAULTNAME);
	}

	/**
	 * This function is the implementation of an abstract method of
	 * IPropertySource class.
	 * It is used to reset the value of all property.
	 * @param id : the id of the selected element
	 */
	public final void resetPropertyValue(final Object id) {

	}

	/**
	 * This function is used to create descriptor.
	 */
	protected final void createDescriptor() {
		addTextDescriptor(NAME, "name : ");
	}

	/**
	 * get the id of the element.
	 * @return the id of this element.
	 */
	public final String getComponentId() {
		return ID;
	}

	/**
	 * This function is used to determine if this element is valide.
	 * @return true is this element is valide.
	 * @param showLog true if the log message must to be show.
	 */
	public final boolean isValide(final boolean showLog) {
		String msg = "";
		boolean returnResult = true;
		if (getName().compareTo("") == 0) {
			msg += "\n- Name => the element name cannot be null";
			returnResult = false;
		}
		if (!returnResult) {
			msg = msg.substring(1);
			msg = "ELEMENT NAME : " + getName() + "\n" + msg;
			if (showLog) {
				CimeroLog.warningLog(msg);
			}
		}
		return returnResult;
	}
}
