package com.bull.cimero.pluginEditor.editors.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;
import com.bull.cimero.pluginEditor.editors.commands.NodeDeleteCommand;
import com.bull.cimero.pluginEditor.editors.model.Diagram;
import com.bull.cimero.pluginEditor.editors.model.GeneriqueCimeroModel;

/**
 * class used to delete component on the draw part (not connections).
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class NodeRemoveEditPolicy extends ComponentEditPolicy {

   /**
    * function to create the delete command.
    * @param request : request sent by Eclipse
    * @return Command : the created command
    */
	@Override
	protected final Command createDeleteCommand(final GroupRequest request) {
	  Object parent = getHost().getParent().getModel();
      NodeDeleteCommand deleteCommand = new NodeDeleteCommand();
      deleteCommand.setDiagram((Diagram) parent);
      deleteCommand.setNode((GeneriqueCimeroModel) getHost().getModel());
      return deleteCommand;
   }
}
