package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.factory.lWFactory.BC;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.factory.lWFactory.GeneriqueLWfactory;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;

/**
 * This class is the BC Component LW Factory.
 * @author Cedric Mouilleron
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public abstract class BCLWFactory extends GeneriqueLWfactory {

	/**variable to determine if the cimero component is a In MEP.*/
	private boolean isInMepMode = false;
	/**the namespace using by this component.*/
	private NameSpaceClass namespaceRef = null;

	/**
	 * The default factory.
	 * @param nms : the namespace using by this factory.
	 * @param mepMode : boolean to determine the mep mode.
	 */
	public BCLWFactory(final NameSpaceClass nms,
			final Boolean mepMode) {
		super();
		this.isInMepMode = mepMode;
		this.namespaceRef = nms;
	}

	/**
	 * @return the isInMepMode
	 */
	public final boolean isInMepMode() {
		return isInMepMode;
	}

	/**
	 * @return the namespaceRef
	 */
	public final NameSpaceClass getNamespaceRef() {
		return namespaceRef;
	}
}
