package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.factory.standardFactory.BC;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.factory.standardFactory.GeneriqueStandardFactory;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;

/**
 * This class is the BC Component Standard Factory.
 * @author Cedric Mouilleron
 * @author Pierre NOTEL
 *  @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public abstract class BCStdFactory extends GeneriqueStandardFactory {


	/**The namespace using by this activation spec.*/
	private NameSpaceClass namespaceRef = null;
	/**mep mode : in or out or inout.*/
	private boolean inMepMode;

	/**
	 * default constructor.
	 * @param nms : the namespace using by this factory
	 * @param mepMode : the mep mode.
	 */
	public BCStdFactory(final NameSpaceClass nms, final Boolean mepMode) {
		this.namespaceRef = nms;
		this.inMepMode = mepMode;
	}

	/**
	 * @return the inMepMode
	 */
	public final boolean isInMepMode() {
		return inMepMode;
	}

	/**
	 * @return the namespaceRef
	 */
	public final NameSpaceClass getNamespaceRef() {
		return namespaceRef;
	}
	
	/**
	 * @return the namespace using by this factory.
	 */
	public final NameSpaceClass getNamespaceComponent() {
		return new NameSpaceClass(getNamespaceName(), getNamespaceValue());
	}

}
