package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.factory.standardFactory.SE;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.factory.standardFactory.GeneriqueStandardFactory;
import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;

/**
 * This class is the SE Component standard Factory.
 * @author Cedric Mouilleron
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public abstract class SEStdFactory extends GeneriqueStandardFactory {

	/**The namespace using by this activation spec.*/
	private NameSpaceClass namespaceRef = null;

	/**
	 * default constructor.
	 * @param nms : the reference of the current namespace.
	 */
	public SEStdFactory(final NameSpaceClass nms) {
		this.namespaceRef = nms;
	}

	/**
	 * @return the namespaceRef
	 */
	public final NameSpaceClass getNamespaceRef() {
		return namespaceRef;
	}

}
