package com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global;

/**
 * This class represents a NameSpace using in ServiceMix.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class NameSpaceClass {

	/**The nameSpace name. */
	private String nameSpaceName = "";
	/**The nameSpace value.*/
	private String nameSpaceValue = "";

	/**
	 * The constructor with parameters.
	 * @param nameSpaceNameParam : the name of the nameSpace
	 * @param nameSpaceValueParam : the value of this nameSpace
	 */
	public NameSpaceClass(final String nameSpaceNameParam,
			final String nameSpaceValueParam) {
		super();
		this.nameSpaceName = nameSpaceNameParam;
		this.nameSpaceValue = nameSpaceValueParam;
	}

	/**
	 * The getter nameSpaceName function.
	 * @return the name of the namespace
	 */
	public final String getNameSpaceName() {
		return nameSpaceName;
	}

	/**
	 * The getter nameSpaceValue function.
	 * @return the value of this namespace
	 */
	public final String getNameSpaceValue() {
		return nameSpaceValue;
	}
}
