package com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model
	.global.standardJBIClassImplementation;

import it.eng.utils.PropertyModel;

import java.util.ArrayList;
import java.util.List;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;


/**
 * The StandardEIPMessageFilder servicemix model.
 * @author Jerome Camillery
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class StandardEIPMessageFilter extends StandardJBIClass implements IServiceEngineClass {
    /**the target name.*/
    private String targetName = "";
    /**the xpat rule.*/
    private String xpathRule = "";
   

    /**The namespace using by this target.*/
    private NameSpaceClass targetNamespace = null;
    /**The namespace using by the service.*/
    private NameSpaceClass serviceNameSpace = null;


    /**
     * @param serviceNameParam : the service name.
     * @param serviceNameSpaceP : the namespace using by this service.
     * @param endpointP : the endpoint service value.
     * @param jbiNms : the jbi namespace.
     * @param targetNameParam : the target name.
     * @param targetNameSpace : the target namespace.
     * @param xpathRuleParam : the xpath rule.
     */
    public StandardEIPMessageFilter(final NameSpaceClass jbiNms,
            final String serviceNameParam,
            final NameSpaceClass serviceNameSpaceP,
            final String targetNameParam,
            final NameSpaceClass targetNameSpace,
            final String xpathRuleParam,
            final String endpointP) {
        super(jbiNms);
        this.serviceName = serviceNameParam;
        this.targetName = targetNameParam;
        this.xpathRule = xpathRuleParam;
        this.targetNamespace = targetNameSpace;
        this.serviceNameSpace = serviceNameSpaceP;
        this.endpointValue = endpointP;
    }


    /**
     * @return the service name.
     */
    public final String getServiceName() {
        return serviceName;
    }


    /**
     * @return the target name.
     */
    public final String getTargetName() {
        return targetName;
    }


    /**
     * @return the xpath rule.
     */
    public final String getXpathRule() {
        return xpathRule;
    }

   

    /**
     * @return the service namespace class.
     */
    public final NameSpaceClass getServiceNameSpace() {
        return serviceNameSpace;
    }

    /**
     * @return the target service namespace.
     */
    public final NameSpaceClass getTargetNamespace() {
        return targetNamespace;
    }
    
    @Override
	public List<PropertyModel> getPropertiesToStore() {
		
		List<PropertyModel> propertiesToStore = new ArrayList<PropertyModel>();
		propertiesToStore.add(createPropertyModel("xpathRule",xpathRule));
		
		
		return propertiesToStore;
	}

}
