package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.global.standardJBIClassImplementation;

import it.eng.utils.PropertyModel;

import java.util.ArrayList;
import java.util.List;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator.model.global.NameSpaceClass;

/**
 * This class represents the traceur in the ServiceMix model.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *
 */
public class StandardEIPWireTap extends StandardJBIClass implements IServiceEngineClass {
	/**the target name.*/
	private String targetName = "";
	/**The target namespace.*/
	private NameSpaceClass targetNamespace = null;
	/**the listerner name.*/
	private String listenerName = "";
	/**The listener namespace.*/
	private NameSpaceClass listenerNamespace = null;


	/**
	 * the constructor with parameter.
	 * @param srcName : the name of the service
	 * @param srcNms : the namespace using by this service.
	 * @param jbiNamespace : the namespace of this component.
	 * @param endOValue : the endpoint value.
	 * @param trgName : the target name.
	 * @param trgNamespace : the target namespace.
	 * @param lstName : the listerner name.
	 * @param lstNamespace : the listener namespace.
	 */
	public StandardEIPWireTap(final String srcName,
			final NameSpaceClass srcNms,
			final NameSpaceClass jbiNamespace,
			final String endOValue,
			final String trgName,
			final NameSpaceClass trgNamespace,
			final String lstName,
			final NameSpaceClass lstNamespace) {
		super(jbiNamespace);
		this.serviceName = srcName;
		this.serviceNamespace = srcNms;
		this.endpointValue = endOValue;
		this.targetName = trgName;
		this.targetNamespace = trgNamespace;
		this.listenerName = lstName;
		this.listenerNamespace = lstNamespace;
	}
	
	/**
	 * @return Returns the listenerName.
	 */
	public final String getListenerName() {
		return listenerName;
	}
	/**
	 * @return Returns the listenerNamespace.
	 */
	public final NameSpaceClass getListenerNamespace() {
		return listenerNamespace;
	}
	/**
	 * @return Returns the serviceName.
	 */
	public final String getServiceName() {
		return serviceName;
	}
	/**
	 * @return Returns the targetName.
	 */
	public final String getTargetName() {
		return targetName;
	}
	/**
	 * @return Returns the targetNamespace.
	 */
	public final NameSpaceClass getTargetNamespace() {
		return targetNamespace;
	}
	
	@Override
	public List<PropertyModel> getPropertiesToStore() {
		
		List<PropertyModel> propertiesToStore = new ArrayList<PropertyModel>();
		
		return propertiesToStore;
	}


}
