package com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.standardModel;

import java.util.ArrayList;
import java.util.List;

import com.bull.cimero.pluginEditor.generator.serviceMixGenerator
	.model.IModelServiceMix;

/**
 * This class represents the service assembly file in the
 * standard ServiceMix model.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 *@author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class ServiceAssemblyClass implements IModelServiceMix {
	/**The name of this service assembly.*/
	private String serviceAssemblyName = "";
	/**The description of this service assembly.*/
	private String serviceAssemblyDescription = "";
	/**The list of serviceUnit that compose this class.*/
	private List < ServiceUnitClass > lstSU = null;

	/**
	 * Constructor with parameter.
	 * @param saName : the name of this SA
	 * @param saDescription : the description
	 */
	public ServiceAssemblyClass(final String saName,
			final String saDescription) {
		super();
		this.serviceAssemblyName = saName;
		this.serviceAssemblyDescription = saDescription;
		//initialise the list
		lstSU = new ArrayList < ServiceUnitClass >();
	}

	/**
	 * add a SU to the list of SU.
	 * @param su : the service Unit .
	 */
	public final void addSU(final ServiceUnitClass su) {
		lstSU.add(su);
	}

	/**
	 * @return Returns the lstSU.
	 */
	public final List < ServiceUnitClass > getLstSU() {
		return lstSU;
	}

	/**
	 * @return Returns the serviceAssemblyDescription.
	 */
	public final String getServiceAssemblyDescription() {
		return serviceAssemblyDescription;
	}

	/**
	 * @return Returns the serviceAssemblyName.
	 */
	public final String getServiceAssemblyName() {
		return serviceAssemblyName;
	}

	/**
	 * @param lstSU the lstSU to set
	 */
	public final void setLstSU(List<ServiceUnitClass> lstSU) {
		this.lstSU = lstSU;
	}



}
