package com.bull.cimero.pluginEditor.utils.exception;

/**
 * This exception is throw during the generation of the cimero jar
 * configuration.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */

public class CimeroGenerateJarException extends Exception {

	/**
	 * serialVersionid.
	 */
	private static final long serialVersionUID = 5594647709197250140L;

	/**
	 * default constructor.
	 */
	public CimeroGenerateJarException() {
		super();
	}

	/**
	 * @param message : the message that explains the error.
	 * @param cause : the exception raise.
	 */
	public CimeroGenerateJarException(final String message,
			final Throwable cause) {
		super(message, cause);
	}

	/**
	 * @param message : the message that explains this exception.
	 */
	public CimeroGenerateJarException(final String message) {
		super(message);
	}

	/**
	 * @param cause : the raise exception.
	 */
	public CimeroGenerateJarException(final Throwable cause) {
		super(cause);
	}

}
