package it.eng.cimero.plugin.dialogs;

public class DataSourceBeanDialog {
	
	private String name = null;
	
	private String driverClassName = null;
	
	private String jdbcUrl = null;
	
	private String user = null;
	
	private String password = null;

	public DataSourceBeanDialog(String name, String driverClassName, String jdbcUrl, String user, String password) {
		super();
		this.name = name;
		this.driverClassName = driverClassName;
		this.jdbcUrl = jdbcUrl;
		this.user = user;
		this.password = password;
	}

	public String getDriverClassName() {
		return driverClassName;
	}

	public void setDriverClassName(String driverClassName) {
		this.driverClassName = driverClassName;
	}

	public String getJdbcUrl() {
		return jdbcUrl;
	}

	public void setJdbcUrl(String jdbcUrl) {
		this.jdbcUrl = jdbcUrl;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getUser() {
		return user;
	}

	public void setUser(String user) {
		this.user = user;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}
	
	public String toJndiConfiguration(){
		StringBuffer sBuf = new StringBuffer();
		
		sBuf.append("<entry key=\"java:comp/env/jdbc/"+name+"\">\n"); 
		sBuf.append("  <bean id=\""+name+"\"\n"); 
		sBuf.append("      class=\"org.apache.commons.dbcp.BasicDataSource\"\n"); 
		sBuf.append("      destroy-method=\"close\">\n"); 
		sBuf.append("      <property name=\"driverClassName\" value=\""+driverClassName+"\"/>\n"); 
		sBuf.append("      <property name=\"url\" value=\""+jdbcUrl+"\"/>\n"); 
		sBuf.append("      <property name=\"username\" value=\""+user+"\"/>\n"); 
		sBuf.append("      <property name=\"password\" value=\""+password+"\"/>\n"); 
		sBuf.append("  </bean>\n"); 
		sBuf.append("</entry>\n");
		
		return sBuf.toString();
	}

	
	
	
}
