package it.eng.cimero.plugin.dialogs;

import it.eng.cimero.plugin.providers.IterTypesContentProvider;
import it.eng.cimero.plugin.providers.IterTypesLabelProvider;
import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.model.AttributeCatalog;
import it.eng.spagosoa.metadb.model.IterType;
import it.eng.spagosoa.metadb.model.Rule;
import it.eng.spagosoa.metadb.model.ServiceAssembly;
import it.eng.utils.DialogUtils;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

public class ListIterTypesDialog extends TitleAreaDialog {
	
    private Composite aComposite = null;
	
    private SashForm internalSash  = null; 
    
    private Table tableIterTypes = null;
    private TableViewer tbvIterTypes = null; 
    private List<IterType> theIterTypes = null;
 
   
    private IMetadbApi metadb = null;
	public ListIterTypesDialog(Shell parentShell, IMetadbApi metadb) {
		
		super(parentShell);
		this.theIterTypes = new ArrayList<IterType>();
		this.metadb = metadb;
	}
	
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
		setTitle("Iter Types Configuration");
	    setMessage("Iter Types Configuration ");
	   
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        this.internalSash = new SashForm(parent,  SWT.VERTICAL | SWT.FLAT);
        this.internalSash.setLayoutData(new GridData(GridData.FILL_BOTH));
       	
    	final ListIterTypesDialog theDialog = this;
    	
    	this.theIterTypes = getIterTypes(); 
    	
    	
        this.tableIterTypes = new Table(internalSash, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER);
        this.tableIterTypes.setLinesVisible(true);
        this.tableIterTypes.setHeaderVisible(true);
        TableColumn column = null;
		column = new TableColumn(tableIterTypes, SWT.LEFT);
		column.setText("Name");
		column.setWidth(200);
		column = new TableColumn(tableIterTypes, SWT.LEFT);
		column.setText("Description");
		column.setWidth(400);
        this.tbvIterTypes = new TableViewer(tableIterTypes);
        tbvIterTypes.setContentProvider(new IterTypesContentProvider());
        tbvIterTypes.setLabelProvider(new IterTypesLabelProvider());
        tbvIterTypes.setInput(this.theIterTypes);    
    	
        
        this.tableIterTypes.addKeyListener(new KeyListener(){
        	public void keyPressed(org.eclipse.swt.events.KeyEvent e) {
        		System.out.println("KeyCode =" +  e.keyCode);
        		if (e.keyCode == 127){
        			TableItem[] tis = theDialog.tableIterTypes.getSelection();
        			IterType selectedIterType = (IterType)tis[0].getData();
        			boolean confirm = MessageDialog.openConfirm(
    						getShell(),
    						"Spagic Studio",
    						"This will remove all data about iter type " + selectedIterType.getName() + " are you sure ? ");
        			if (confirm){
        				deleteIterType(selectedIterType);
        				theDialog.tbvIterTypes.setInput(getIterTypes());
        				theDialog.tbvIterTypes.refresh();
        			}
        			
        		}
        	};
        	public void keyReleased(org.eclipse.swt.events.KeyEvent e) {
        		
        	};
        	
        });
        
        tbvIterTypes.addDoubleClickListener(new IDoubleClickListener(){
			public void doubleClick(DoubleClickEvent event) {
				TableItem[] selection = tableIterTypes.getSelection();
				IterType selectedIterType = null;
        		if ((selection != null) && (selection.length > 0)){
        			selectedIterType = (IterType)((TableItem)selection[0]).getData();
    				DetailIterTypeDialog detailIterTypeDialog = new DetailIterTypeDialog( getShell(),selectedIterType,metadb);
            		detailIterTypeDialog.open();
            		theDialog.tbvIterTypes.setInput(getIterTypes());
    				theDialog.tbvIterTypes.refresh();
    			}
			}});
        
        aComposite = new Composite(internalSash, SWT.NONE);
		final GridLayout layout = new GridLayout();
    	layout.marginWidth = 15;
    	layout.marginHeight = 10;
    	layout.numColumns = 12;
    	aComposite.setLayout(layout);
    	aComposite.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    	
    	Button btnAddIterType = new Button(aComposite, SWT.FLAT);
    	btnAddIterType.setText(" New Iter Type ");
    	GridData data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	btnAddIterType.setLayoutData(data);
    	
    	Button btnModifyIterIterType = new Button(aComposite, SWT.FLAT);
    	btnModifyIterIterType.setText(" Modify Iter Type ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	btnModifyIterIterType.setLayoutData(data);
    	
    	
    	
    	
         
    	btnAddIterType.addListener(SWT.Selection, 
    		new Listener() {
            	public void handleEvent(Event event) {
            		
             		DetailIterTypeDialog detailIterTypeDialog = new DetailIterTypeDialog(getShell(),metadb);
            		detailIterTypeDialog.open();
            		theDialog.tbvIterTypes.setInput(getIterTypes());
    				theDialog.tbvIterTypes.refresh();
            }});
    	
    	btnModifyIterIterType.addListener(SWT.Selection, 
    		new Listener() {
            	public void handleEvent(Event event) {
            		TableItem[] selection = tableIterTypes.getSelection();
            		IterType selectedIterType = null;
            		if ((selection != null) && (selection.length > 0)){
            			selectedIterType = (IterType)((TableItem)selection[0]).getData();
            			DetailIterTypeDialog detailIterTypeDialog = new DetailIterTypeDialog( getShell(),selectedIterType,metadb);
                		detailIterTypeDialog.open();
                		theDialog.tbvIterTypes.setInput(getIterTypes());
        				theDialog.tbvIterTypes.refresh();
            		}else{
            			DialogUtils.warning(
        						getShell(),
        						"No iter type selected ");
            		}
             		
            }});
    	
    	
    	
    	internalSash.setWeights(new int[] {60,40});
        return parent;
	}
	
	protected void okPressed() {
		super.okPressed();
		
	}
	



	protected void createButtonsForButtonBar(Composite parent) {
		
		
	}

	
	protected List<IterType> getIterTypes(){
		metadb.open();
		List<IterType> result = metadb.getIterTypes();
		metadb.close();
		return result;
	}
		
	private boolean deleteIterType(IterType iterType){
		try {
			metadb.openTx();
			metadb.deleteIterType(iterType);
			metadb.commitAndClose();
			return true;
		} catch (Throwable t) {
			metadb.rollBackAndClose();
			return false;
		}
		
	}
	
	




	




	
	
}
