package it.eng.cimero.plugin.dialogs;

import it.eng.cimero.plugin.providers.RulesContentProvider;
import it.eng.cimero.plugin.providers.RulesLabelProvider;
import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.model.IterType;
import it.eng.spagosoa.metadb.model.Rule;
import it.eng.spagosoa.metadb.model.ServiceAssembly;
import it.eng.utils.DialogUtils;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

public class ListRulesDialog extends TitleAreaDialog {
	
    private Composite aComposite = null;
	
    private SashForm internalSash  = null; 
    
    private Table tableRules = null;
    private TableViewer tbvRules = null; 
    private List<Rule> theRules = null;
    
    private Rule selectedRule = null;
    
    private boolean closeOnDoubleClick = false;
    private IMetadbApi metadb = null;
    private String message = null;
    
	public ListRulesDialog(Shell parentShell, IMetadbApi metadb) {
		
		super(parentShell);
		this.theRules = new ArrayList<Rule>();
		this.metadb = metadb;
		
	}
	
	public ListRulesDialog(Shell parentShell, IMetadbApi metadb, boolean closeOnDoubleClick, String message) {
		
		super(parentShell);
		this.theRules = new ArrayList<Rule>();
		this.metadb = metadb;
		this.closeOnDoubleClick = closeOnDoubleClick;
	}
	
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
		setTitle("Rules");
		if (message == null)
			message = "Rules";
	    setMessage(message);
	   
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        this.internalSash = new SashForm(parent,  SWT.VERTICAL | SWT.FLAT);
        this.internalSash.setLayoutData(new GridData(GridData.FILL_BOTH));
       	
    	final ListRulesDialog theDialog = this;
    	
    	this.theRules = getRules(); 
    	
    	
        this.tableRules = new Table(internalSash, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER);
        this.tableRules.setLinesVisible(true);
        this.tableRules.setHeaderVisible(true);
        TableColumn column = null;
		column = new  TableColumn(tableRules, SWT.LEFT);
		column.setText("Rule Description");
		column.setWidth(450);
		this.tableRules.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
        this.tbvRules = new TableViewer(tableRules);
        tbvRules.setContentProvider(new RulesContentProvider());
        tbvRules.setLabelProvider(new RulesLabelProvider());
        
    	tbvRules.setInput(theRules);
        
    	
        
        tbvRules.addDoubleClickListener(new IDoubleClickListener(){
			public void doubleClick(DoubleClickEvent event) {
				
				if (closeOnDoubleClick){
					TableItem[] selection = tableRules.getSelection();
					if ((selection != null) && (selection.length > 0)){
            			selectedRule = (Rule)((TableItem)selection[0]).getData();
            			close();
            		}else{
            			DialogUtils.confirm(
        						getShell(),
        						"Select a rule ");
            		}
				}
				
			}});
        
        /*
        aComposite = new Composite(internalSash, SWT.NONE);
		final GridLayout layout = new GridLayout();
    	layout.marginWidth = 15;
    	layout.marginHeight = 10;
    	layout.numColumns = 10;
    	aComposite.setLayout(layout);
    	aComposite.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    	
    
    	Button btnAddRule = new Button(aComposite, SWT.FLAT);
    	btnAddRule.setText(" New Rule ");
    	GridData data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 5;
    	btnAddRule.setLayoutData(data);
    	
    	Button btnModifyRule = new Button(aComposite, SWT.FLAT);
    	btnModifyRule.setText(" Modify Rule ");
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 5;
    	btnModifyRule.setLayoutData(data);
    	
    	
         
    	btnAddRule.addListener(SWT.Selection, 
    		new Listener() {
            	public void handleEvent(Event event) {
            		
             		DetailRuleDialog detailRuleDialog = new DetailRuleDialog( getShell(),null, metadb);
             		detailRuleDialog.open();
            		theDialog.tbvRules.setInput(getRules());
    				theDialog.tbvRules.refresh();
            }});
    	
    	btnModifyRule.addListener(SWT.Selection, 
    		new Listener() {
            	public void handleEvent(Event event) {
            		TableItem[] selection = tableRules.getSelection();
            		Rule selectedRule = null;
            		if ((selection != null) && (selection.length > 0)){ 
            			selectedRule = (Rule)((TableItem)selection[0]).getData();
            			DetailRuleDialog detailRuleDialog = new DetailRuleDialog(getShell(),selectedRule, metadb);
                 		detailRuleDialog.open();
                 		
                 		theDialog.tbvRules.setInput(getRules());
        				theDialog.tbvRules.refresh();
            		}else{
            			DialogUtils.warning(
        						getShell(),
        						"No rule selected");
            		}
            		
            }});
    	internalSash.setWeights(new int[] {60,40});
        */
        return parent; 
	
	}
	
	protected void okPressed() {
		super.okPressed();
		
	}
	
	@Override
	protected void buttonPressed(int buttonId) {
	
		super.buttonPressed(buttonId);
	}


	protected void createButtonsForButtonBar(Composite parent) {
		// create OK and Cancel buttons by default
		createButton(parent, IDialogConstants.OK_ID, IDialogConstants.CLOSE_LABEL,
				true);
		
	}

	
	
	



	public List<Rule> getRules(){
		metadb.open();
		List<Rule> result = metadb.getRelevantDataRules();
		metadb.close();
		return result;
	}
	
	

	public Rule getSelectedRule() {
		return selectedRule;
	}

	public void setSelectedRule(Rule selectedRule) {
		this.selectedRule = selectedRule;
	}



	
	
}
