package it.eng.cimero.plugin.dialogs;

import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.model.AttributeCatalog;
import it.eng.spagosoa.metadb.model.Catalog;

import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class NewCatalogDialog extends TitleAreaDialog {

//	final SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");
	

    private Composite aComposite = null;
    private CLabel catalogNameLabel = null;
    private Text catalogNameTextField = null;
    
    private CLabel catalogVisibleLabel = null;
    private Button catalogVisibleCheckBox = null;
    private CLabel catalogMandatoryLabel = null;
    private Button catalogMandatoryCheckBox = null;
    
    
    
    private IMetadbApi metadb = null;
    
    
	public NewCatalogDialog(Shell parentShell, IMetadbApi metadb) {
		super(parentShell);
		this.metadb = metadb;
	}
	
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
	    
	    setTitle("New Catalog");
	    setMessage("New Catalog");
	    
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        
  
		
		aComposite = new Composite(parent, SWT.NONE);
		final GridLayout layout = new GridLayout();
    	layout.marginWidth = 15;
    	layout.marginHeight = 10;
    	layout.numColumns = 5;
    	aComposite.setLayout(layout);
    	aComposite.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    	
    	
    	GridData data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	
    	
    	
    	
    	// Riga 2
    	catalogNameLabel = new CLabel(aComposite, SWT.RIGHT);
    	catalogNameLabel.setText(" Catalog Name ");
    	catalogNameTextField = new Text(aComposite, SWT.BORDER | SWT.FLAT );
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	catalogNameTextField.setLayoutData(data);
    	
    	
    	catalogVisibleLabel = new CLabel(aComposite, SWT.RIGHT);
    	catalogVisibleLabel.setText(" Is Visible ");
    	catalogVisibleCheckBox = new Button(aComposite, SWT.CHECK );
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	catalogVisibleCheckBox.setLayoutData(data);
    		

    	catalogMandatoryLabel = new CLabel(aComposite, SWT.RIGHT);
    	catalogMandatoryLabel.setText(" Is Mandatory ");
    	catalogMandatoryCheckBox = new Button(aComposite, SWT.CHECK );
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	catalogMandatoryCheckBox.setLayoutData(data);
    		
        return parent; 
	
	}
	
	protected void okPressed() {
		metadb.openTx();
		Catalog newCatalog = new Catalog();
		newCatalog.setName(catalogNameTextField.getText());
		newCatalog.setVisible(this.catalogVisibleCheckBox.getSelection());
		newCatalog.setMandatory(this.catalogMandatoryCheckBox.getSelection());
		metadb.storeCatalog(newCatalog);
		metadb.commitAndClose();
		super.okPressed();
		
	}
	
	@Override
	protected void buttonPressed(int buttonId) {
		
		super.buttonPressed(buttonId);
	}




	
	
}
