package it.eng.cimero.plugin.dialogs;

import it.eng.cimero.plugin.providers.DataSourceBeanContentProvider;
import it.eng.cimero.plugin.providers.DataSourceBeanLabelProvider;
import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.model.IterType;
import it.eng.utils.DialogUtils;

import java.io.File;
import java.io.FileWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;

import javax.swing.text.TabExpander;

import org.apache.axis.NoEndPointException;
import org.dom4j.Branch;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.Node;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.SAXReader;
import org.dom4j.io.XMLWriter;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

import cimeroEditor.CimeroEditorPlugin;

import com.bull.cimero.pluginEditor.utils.log.CimeroLog;

public class SelectDataSourcesDialog extends TitleAreaDialog {
	
 
	
    private SashForm internalSash  = null; 
    
    private Table tableDatasources = null;
    private TableViewer tbvDatasources = null; 
    private List<DataSourceBeanDialog> theDatasources = null;
   
    private List<DataSourceBeanDialog> selectedDatasources = null;
    private String title = null;
 
	public SelectDataSourcesDialog(Shell parentShell, String title, List<DataSourceBeanDialog> dataSourcesList) {
		super(parentShell);
		this.title=title;
		this.theDatasources = dataSourcesList;
	}
	
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
		setTitle(this.title);
	    setMessage("Select Datasources from list and then click import to add to spagic studio ");
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        this.internalSash = new SashForm(parent,  SWT.VERTICAL | SWT.FLAT);
        this.internalSash.setLayoutData(new GridData(GridData.FILL_BOTH));
       	
    	final SelectDataSourcesDialog theDialog = this;
    	
    	
        this.tableDatasources = new Table(internalSash, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER);
        this.tableDatasources.setLinesVisible(true);
        this.tableDatasources.setHeaderVisible(true);
        TableColumn column = null;
		column = new TableColumn(tableDatasources, SWT.LEFT);
		column.setText("Name");
		column.setWidth(200);
		column = new TableColumn(tableDatasources, SWT.LEFT);
		column.setText("Driver");
		column.setWidth(200);
		column = new TableColumn(tableDatasources, SWT.LEFT);
		column.setText("url");
		column.setWidth(200);
		column = new TableColumn(tableDatasources, SWT.LEFT);
		column.setText("user");
		column.setWidth(200);
        this.tbvDatasources = new TableViewer(tableDatasources);
        tbvDatasources.setContentProvider(new DataSourceBeanContentProvider());
        tbvDatasources.setLabelProvider(new DataSourceBeanLabelProvider());
        tbvDatasources.setInput(this.theDatasources);    

        return parent;
	}
	@Override
	protected void okPressed() {
		
		TableItem[] selection = this.tableDatasources.getSelection();
		if (selection != null && selection.length > 0){
			this.selectedDatasources = new ArrayList<DataSourceBeanDialog>();
			for (int i=0; i < selection.length; i++){
				this.selectedDatasources.add((DataSourceBeanDialog)selection[i].getData());
			}
		}
		super.okPressed();
	}
	
	
	@Override
	protected void cancelPressed() {
		
		this.selectedDatasources = null;
		super.cancelPressed();
	}



	protected void createButtonsForButtonBar(Composite parent) {
	
		
		createButton(parent, IDialogConstants.OK_ID, "Import In Spagic Studio",
				true);
		createButton(parent, IDialogConstants.CANCEL_ID, IDialogConstants.CANCEL_LABEL,
				true);
	}




	public List<DataSourceBeanDialog> getSelectedDatasources() {
		return selectedDatasources;
	}




	public void setSelectedDatasources(
			List<DataSourceBeanDialog> selectedDatasources) {
		this.selectedDatasources = selectedDatasources;
	}
	




	




	
	
}
