package it.eng.utils;
/**
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
import it.eng.spagosoa.metadb.api.IMetadbApi;
import it.eng.spagosoa.metadb.impl.HibernateMetadbImpl;
import it.eng.spagosoa.metadb.model.ServiceAssembly;

import java.util.List;

import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;

import com.bull.cimero.pluginEditor.utils.log.CimeroLog;

public class SvgGenerator {

	public static void main(String[] args) {
		
		IMetadbApi metadb = null;
		try{
			metadb = new HibernateMetadbImpl(getSessionFactory());
			metadb.openTx();
			List<ServiceAssembly> result = metadb.getServiceAssemblies();
			for (ServiceAssembly sa : result){
				String svg = ProcessModelsUtils.getSvgForSa(metadb, sa, "C:/Programmi/ATT/Graphviz/bin/dot", "C:/tmp");
				if (svg != null && svg.trim().length() > 0 ){
					metadb.storeSvgForSA(sa, svg);
				}else{
					System.out.println("-> SVG Not Stored ["+sa.getName()+"] results in a empty image " );	
				}
			}
						
			metadb.commitAndClose();
		}catch (Throwable e) {
			metadb.rollBackAndClose();
		}finally{
			
		}
	}
	
	public static SessionFactory getSessionFactory(){
		
		
		Configuration cfg = new Configuration().configure("/hibernate.cfg.xml");	
		
	
		cfg.setProperty("hibernate.connection.driver_class", "com.mysql.jdbc.Driver");
		cfg.setProperty("hibernate.connection.url","jdbc:mysql://localhost:3306/smx");
		cfg.setProperty("hibernate.connection.username","smx");
		cfg.setProperty("hibernate.connection.password","smx");
    
		cfg.setProperty("hibernate.dialect","org.hibernate.dialect.MySQLInnoDBDialect");
		cfg.setProperty("hibernate.show_sql","true");
    
		return cfg.buildSessionFactory();
		
	}
}
